pub use benchmark_cli::BenchmarkCli;
use clap::{Parser, Subcommand};
pub use cli_solution_to_solve::CliSolutionToSolve;
pub use given_day::GivenDay;
pub use given_task::GivenTask;

mod benchmark_cli;
mod cli_solution_to_solve;
mod given_day;

mod given_task;

#[derive(Debug, Subcommand)]
pub enum AppCliSubcommands {
    Solve(CliSolutionToSolve),
    Benchmark(BenchmarkCli),
}

#[derive(Debug, Parser)]
pub struct AppCliArgs {
    #[command(subcommand)]
    sub_command: AppCliSubcommands,
}

impl AppCliArgs {
    pub fn sub_command(&self) -> &AppCliSubcommands {
        &self.sub_command
    }
}
